(* $Id: lib_pp.mli,v 1.7 2012/06/17 15:21:51 weis Exp $ *)

(** The runtime library for pretty-readers and pretty-printers
   generated with OCamlGen. *)

(** Runtime library for pretty-printers generated with OCamlGen. *)

open Format_printer;;

val print_quoted_int32 : int32 printer;;
val print_quoted_int64 : int64 printer;;
val print_quoted_nativeint : nativeint printer;;
val print_quoted_float : float printer;;

val print_List : ('a, 'a list) printer_lifter;;
val print_Array : ('a, 'a array) printer_lifter;;
val print_Option : ('a, 'a option) printer_lifter;;

val print_fun : 'a printer -> 'b printer -> ('a -> 'b) printer;;

val print_poly : 'a printer;;
val print_abstract : 'a printer;;
val print_external : 'a printer;;

val print_list :
  ('a, Format.formatter, unit) format ->
  ('b, 'b list) printer_lifter
;;
val print_array :
  ('a, Format.formatter, unit) format ->
  ('b, 'b array) printer_lifter
;;
val print_option :
  ('a, Format.formatter, unit) format ->
  ('b, 'b option) printer_lifter
;;

(** Runtime library for pretty-readers generated with OCamlGen. *)

open Scanf_reader;;

val read_unit : unit Scanf_reader.reader;;
val read_bool : bool reader;;
val read_quoted_string : string reader;;
val read_quoted_char : char reader;;
val read_quoted_int : int reader;;
val read_quoted_nativeint : nativeint reader;;
val read_quoted_int32 : int32 reader;;
val read_quoted_int64 : int64 reader;;
val read_quoted_float : float reader;;

val read_List : ('a, 'a list) reader_lifter;;
val read_Array : ('a, 'a array) reader_lifter;;
val read_Option : ('a, 'a option) reader_lifter;;

val read_fun : ('a -> 'b) reader;;
val read_poly : 'a reader;;

val read_list :
  ('a, Scanf.Scanning.in_channel, 'b, 'c, 'a -> 'd, 'd) format6 ->
  ('e, 'e list) reader_lifter
;;
val read_array :
  ('a, Scanf.Scanning.in_channel, 'b, 'c, 'a -> 'd, 'd) format6 ->
  ('e, 'e array) reader_lifter
;;
val read_option :
  ('a, Scanf.Scanning.in_channel, 'b, 'c, 'a -> 'd, 'd) format6 ->
  ('e, 'e option) reader_lifter
;;
