(* $Id: caml_read.ml,v 1.4 2012/07/26 13:39:09 fclement Exp $ *)

module P : Generator_spec.Prefix =

struct

  let function_prefix = "read_";;
  let type_var_arg_prefix = "r_";;
  let external_module_suffix = "_read";;
  let output_file_suffix = "_read";;
  let buffer_argument =
    Some ("ib",
      Og_types.Const_type (
        Og_types.Ldot (
          Og_types.Ldot (Og_types.Lident "Scanf", "Scanning"),
          "scanbuf")
      )
    )
  ;;

end
;;

(* The module that builds the walker ast. *)
module Make_walker = Generator.Make (P);;

module Treat (Io : Walk_spec.Out) =

struct

  (* The module that generates readers. *)
  module Walker = Walk_read.Reader (Io);;

  let file ast =
    (* Prints the type definition, if necessary. *)
    if Og_config.get_keep_type_definitions ()
      then Og_types_print.file Io.buffer ast;
    (* And the printer definition. *)
    let walker_ast = Make_walker.file ast in
    Walker.file walker_ast
  ;;

end;;

module Main = Walk_file.Main (P) (Treat);;

Printexc.catch Main.main();;
